	// ===============================================================
	// Global Var
	// ===============================================================
	
	// Edit Handler
	// _______________________________________________________________________
	var EDIT_HANDLER = function(){};	
	EDIT_HANDLER.REF_IS_MODIFIED = false;
	EDIT_HANDLER.HAS_NEWLY_SAVED_DATA = false;
	var PROPERTY_PARENT_ID = 0;
	var PROPERTY_PARENT_DESCRIPTION = "";
	
	
	// Cache
	// _______________________________________________________________________
	var PROPERTY_REC_INVOICE_ID = -1;
	var PROPERTY_EDIT_MODE = false;
	var PROPERTY_EDIT_ROW_INDEX = -1;
	var INPUT_INSTANCE = null;
	
	
	// Buttons [Optional]
	// _______________________________________________________________________
	var ADD_BBI = null;
	var SAVE_BBI = null;
	var DELETE_BBI = null;
	var CANCEL_BBI = null;
	var NAVIGATION_BACK_BBI = null;
	
	var LOAD_MORE_BBI = null;
	var LOAD_PREV_BBI = null;
	var LOAD_NEXT_BBI = null;
	var LOAD_PAGING_CMB = null;
	var LOAD_PAGING_IGNORE_NEXT_REQUEST = false;
	
	var SEARCH_CMD = null;
	var PRINT_BBI = null;
	var EXPORT_BBI = null;
	
	
	// Dialog Controls [Optional]
	// _______________________________________________________________________
	var REC_INVOICE_REFERENCE_TXT = null;
	var REC_INVOICE_ACC_GROUP_ID_CMB = null;
	var REC_INVOICE_NAME_TXT = null;
	var REC_INVOICE_DISCOUNT_OTHER_TXT = null;
	var REC_INVOICE_AMOUNT_DUE_TXT = null;
	var REC_INVOICE_AMOUNT_RETURN_TXT = null;
	var REC_INVOICE_AMOUNT_ADJUSTMENT_TXT = null;
	var REC_INVOICE_AMOUNT_PAID_TXT = null;
	var REC_INVOICE_REMARKS_TXT = null;
	var REC_INVOICE_REC_EMPLOYEE_ID_CMB = null;
	var REC_INVOICE_DATE_DELIVERY_DTP = null;
	var REC_INVOICE_DATE_DUE_DTP = null;
	var REC_INVOICE_STATUS_CMB = null;
	
	var SEARCH_REC_INVOICE_DATE_DELIVERY_CMB = null;
	var SEARCH_REC_INVOICE_DATE_ISSUED_CMB = null;
	var SEARCH_REC_INVOICE_DATE_DUE_CMB = null;
	var SEARCH_REC_INVOICE_DATE_FULLPAY_CMB = null;
	
	var PARAM_REC_INVOICE_ID_FILE_FP = null;
	
	
	// DGV Controls
	// _______________________________________________________________________
	var INVOICE_DGV = null;
	var INVOICE_LAST_GET_MAP_ARRAY = null;


	// ===============================================================
	// Initialize Controls
	// ===============================================================     
	function FORM_INITIALIZE()
	{
		// Load Cache Parent Data [Add Redirects if this is a required data.]
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID_INVOICE"))
		{
			PROPERTY_PARENT_ID = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_ID_INVOICE");
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS];
			//window.close();
		}
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION_INVOICE"))
		{
			PROPERTY_PARENT_DESCRIPTION = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_DESCRIPTION_INVOICE");
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_PARENT_DESCRIPTION_TXT") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_PARENT_DESCRIPTION_TXT", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_PARENT_DESCRIPTION_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_PARENT_DESCRIPTION_LBL", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_TITLE_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_TITLE_LBL", JSOC_ELEMENT.VAR_VALUE("PAGE_TITLE_LBL") + " : " + PROPERTY_PARENT_DESCRIPTION);	
			}
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS];	
		}
	
		// Restore Cache on reload
		// ...........................................	
		if
		(
			JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID_INVOICE") || 
			JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION_INVOICE")
		)
		{
			  window.onbeforeunload = function(event)
			  {
					// Get Current Root path
					var CURRENT_ROOT_PATH = JSCUS_CACHE.ROOT_PATH + JSVC_STR.VAR_MID(JSVC_STR.VAR_DLEFT(JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS], JSCUS_CACHE.SERVER_URL.length), 1, 1);
				
					// Cache Primary Key
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_ID_INVOICE', 
						PROPERTY_PARENT_ID, 
						5, 
						CURRENT_ROOT_PATH
					);
					
					// Cache Description
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_DESCRIPTION_INVOICE', 
						PROPERTY_PARENT_DESCRIPTION, 
						5, 
						CURRENT_ROOT_PATH
					);
			  };
		}
		
		// Assign Fixed Parent (Must remove auto-populate at ch.js and HTTP_PARENT_LOAD at eh.js)
		// ...........................................
		/*
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PARENT_SELECT_CMB"))
		{
			JSOC_CMB.VAR_ADD
			(
				"PARENT_SELECT_CMB", 
				PROPERTY_PARENT_ID,
				PROPERTY_PARENT_DESCRIPTION
			);
		}
		*/
		
		
 		// Cache Class Properties
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_REC_INVOICE_ID"))
		{
			PROPERTY_REC_INVOICE_ID = JSVC_COOKIE.VAR_READ("PROPERTY_REC_INVOICE_ID");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_EDIT_MODE"))
		{
			PROPERTY_EDIT_MODE = JSVC_COOKIE.VAR_READ("PROPERTY_REC_INVOICE_ID");
		}
	
		// Initialize: Modals
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("INVOICE_MODAL") == true)
		{
			// Display Modal
			JSOC_DIALOG.VAR_MODAL("INVOICE_MODAL", false);
		}
				
		// Initialize: Ribbon Buttons [Add Item]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ADD_BBI"))
		{
    		ADD_BBI = JSOC_ELEMENT.VAR_GET("ADD_BBI");     	
			
			// Add OnClick event [Show Modal]
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("INVOICE_MODAL"))
			{
				ADD_BBI.onclick = function()
				{		
					JSOC_DIALOG.VAR_MODAL("NEW_INVOICE_MODAL", true);
				};					
			}
			// Add OnClick event [Show Add/Edit Page]
			else
			{
				
			}
		}	
		
		// Initialize: Ribbon Buttons [Save Changes]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SAVE_BBI"))
		{
    		SAVE_BBI = JSOC_ELEMENT.VAR_GET("SAVE_BBI");     
			if(JSVC_VAR.VAR_ISSET(HTTP_SAVE))
			{
				// Prepare Save callback
				var CALLBACK_HANDLER = 
					function(IS_SUCCESS)
					{
						// Abort on failure
						if(IS_SUCCESS == false)
						{
							return;
						}
					
						// Show record saved messageBox
						JSVC_INFO.VAR_RECORD_SAVED('');
					};
				
				// Add OnClick event
				SAVE_BBI.onclick = 
					function()
					{
						HTTP_SAVE(CALLBACK_HANDLER);
					};
			}
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CANCEL_BBI"))
		{
    		CANCEL_BBI = JSOC_ELEMENT.VAR_GET("CANCEL_BBI");      		
		}
		
		// Initialize: Ribbon Buttons [Add Back Link (to parent page)]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("NAVIGATION_BACK_BBI"))
		{
    		NAVIGATION_BACK_BBI = JSOC_ELEMENT.VAR_GET("NAVIGATION_BACK_BBI");  
			
			// Add OnClick event
			NAVIGATION_BACK_BBI.onclick = 
				function()
				{
				};
		}
		
		// Initialize: Ribbon Buttons [Add Forward Link (to child page)]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("NAVIGATION_BACK_BBI"))
		{
    		NAVIGATION_BACK_BBI = JSOC_ELEMENT.VAR_GET("NAVIGATION_BACK_BBI");  
			
			// Add OnClick event
			NAVIGATION_BACK_BBI.onclick = 
				function()
				{
				};	
		}
		
		// Initialize: Load more items to the list
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_MORE_BBI"))
		{
    		LOAD_MORE_BBI = JSOC_ELEMENT.VAR_GET("LOAD_MORE_BBI");  
			LOAD_MORE_BBI.onclick = 
				function()
				{
					HTTP_SEARCH_LOAD_MORE();
				};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_PREV_BBI"))
		{
    		LOAD_PREV_BBI = JSOC_ELEMENT.VAR_GET("LOAD_PREV_BBI");  
			LOAD_PREV_BBI.onclick = 
				function()
				{
					var CURRENT_INDEX = JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB);
					if(CURRENT_INDEX > 0)
					{
						JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB, CURRENT_INDEX - 1);
						LOAD_PAGING_CMB.onchange();
					}
				};
		}		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_NEXT_BBI"))
		{
    		LOAD_NEXT_BBI = JSOC_ELEMENT.VAR_GET("LOAD_NEXT_BBI");  
			LOAD_NEXT_BBI.onclick = 
				function()
				{
					var CURRENT_INDEX = JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB);
					if(CURRENT_INDEX + 1 < JSOC_CMB.VAR_COUNT(LOAD_PAGING_CMB))
					{
						JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB, CURRENT_INDEX + 1);
						LOAD_PAGING_CMB.onchange();
					}
				};
		}		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_PAGING_CMB"))
		{
    		LOAD_PAGING_CMB = JSOC_ELEMENT.VAR_GET("LOAD_PAGING_CMB");  
			LOAD_PAGING_CMB.onchange = 
				function()
				{
					HTTP_SEARCH_LOAD_PAGE();
				};
		}

		// Initialize: Ribbon Buttons [Add Search]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_CMD"))
		{
			SEARCH_CMD = JSOC_ELEMENT.VAR_GET("SEARCH_CMD");
			SEARCH_CMD.onclick = function(){HTTP_SEARCH();};
		}		

		// Initialize: Ribbon Buttons [Add Print]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PRINT_BBI"))
		{
			PRINT_BBI = JSOC_ELEMENT.VAR_GET("PRINT_BBI");
			PRINT_BBI.onclick = function()
			{
				window.print();
			};
		}		
		
		// Initialize: Ribbon Buttons [Add Search]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("EXPORT_BBI"))
		{
			EXPORT_BBI = JSOC_ELEMENT.VAR_GET("EXPORT_BBI");
			EXPORT_BBI.onclick = function()
			{
				JSOC_DIALOG.VAR_LOADING_SPINNER(true);
				JSRC_THREAD.REF_POST_DELAYED			
				(
					async function()
					{
						await JSRC_EXCEL.REF_EXPORT('INVOICE_DGV');
						CUS_SEND_DIALOG_TRY_DISMISS();
					},
					100
				);
			};
		}		

		
		// Prepare onChange event
		// ...........................................
		var ON_CHANGE_EVENT = '';
		
		
		// Initialize: Input Controls
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_INVOICE_ID_TXT"))
		{
			REC_INVOICE_ID_TXT = JSOC_ELEMENT.VAR_GET("REC_INVOICE_ID_TXT");      
			REC_INVOICE_ID_TXT.onchange = 
				function()
				{
					if(REC_INVOICE_ID_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			REC_INVOICE_ID_TXT.onkeypress = function(){REC_INVOICE_ID_TXT.onchange();};
			REC_INVOICE_ID_TXT.onpaste = function(){REC_INVOICE_ID_TXT.onchange();};
			//REC_INVOICE_ID_TXT.oninput = function(){REC_INVOICE_ID_TXT.onchange();};
		}

		REC_INVOICE_CODE_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_CODE_TXT");
		REC_INVOICE_REFERENCE_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_REFERENCE_TXT");
		REC_INVOICE_ACC_GROUP_ID_CMB = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_ACC_GROUP_ID_CMB");
		REC_INVOICE_NAME_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_NAME_TXT");
		REC_INVOICE_LINE_TOTAL_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_LINE_TOTAL_TXT");
		REC_INVOICE_LINE_DISCOUNT_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_LINE_DISCOUNT_TXT");
		REC_INVOICE_DISCOUNT_OTHER_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP
		(
			"REC_INVOICE_DISCOUNT_OTHER_TXT", null, function()
			{
					if(REC_INVOICE_DISCOUNT_OTHER_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
					
					JSOC_ELEMENT.VAR_VALUE
					(
						"REC_INVOICE_AMOUNT_DUE_TXT",
						(
							INVOICE_LINE_DGV.COLUMN.SUM("SUBTOTAL") +
							JSOC_ELEMENT.VAR_VALUE_NVAL("REC_INVOICE_AMOUNT_ADJUSTMENT_TXT")
						) - 
						(
							JSOC_ELEMENT.VAR_VALUE_NVAL("REC_INVOICE_DISCOUNT_OTHER_TXT") +
							INVOICE_RTN_DGV.COLUMN.SUM("SUBTOTAL")
						)
					)			
			}
		);
		REC_INVOICE_AMOUNT_DUE_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_AMOUNT_DUE_TXT");
		REC_INVOICE_AMOUNT_RETURN_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_AMOUNT_RETURN_TXT");
		REC_INVOICE_AMOUNT_ADJUSTMENT_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_AMOUNT_ADJUSTMENT_TXT");
		REC_INVOICE_AMOUNT_PAID_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_AMOUNT_PAID_TXT");
		REC_INVOICE_REMARKS_TXT = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_REMARKS_TXT");
		REC_INVOICE_REC_EMPLOYEE_ID_CMB = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_REC_EMPLOYEE_ID_CMB");

		DTP_BLOCK = JSCUS_PG._TOOL.APPLY_DTP_FROM_TO_SETUP("REC_INVOICE_DATE_DELIVERY", null, null, null, null, 3);
		REC_INVOICE_DATE_DELIVERY_DTP = DTP_BLOCK[0];
		SEARCH_REC_INVOICE_DATE_DELIVERY_CMB = DTP_BLOCK[1];
		SEARCH_REC_INVOICE_DATE_DELIVERY_FROM_DTP = DTP_BLOCK[2];
		SEARCH_REC_INVOICE_DATE_DELIVERY_TO_DTP = DTP_BLOCK[3];
	
		DTP_BLOCK = JSCUS_PG._TOOL.APPLY_DTP_FROM_TO_SETUP("REC_INVOICE_DATE_ISSUED", null, null, null, null, 3);
		REC_INVOICE_DATE_ISSUED_DTP = DTP_BLOCK[0];
		SEARCH_REC_INVOICE_DATE_ISSUED_CMB = DTP_BLOCK[1];
		SEARCH_REC_INVOICE_DATE_ISSUED_FROM_DTP = DTP_BLOCK[2];
		SEARCH_REC_INVOICE_DATE_ISSUED_TO_DTP = DTP_BLOCK[3];
	
		DTP_BLOCK = JSCUS_PG._TOOL.APPLY_DTP_FROM_TO_SETUP("REC_INVOICE_DATE_DUE", null, null, null, null, 3);
		REC_INVOICE_DATE_DUE_DTP = DTP_BLOCK[0];
		SEARCH_REC_INVOICE_DATE_DUE_CMB = DTP_BLOCK[1];
		SEARCH_REC_INVOICE_DATE_DUE_FROM_DTP = DTP_BLOCK[2];
		SEARCH_REC_INVOICE_DATE_DUE_TO_DTP = DTP_BLOCK[3];
		
		DTP_BLOCK = JSCUS_PG._TOOL.APPLY_DTP_FROM_TO_SETUP("REC_INVOICE_DATE_FULLPAY", null, null, null, null, 3);
		REC_INVOICE_DATE_FULLPAY_DTP = DTP_BLOCK[0];
		SEARCH_REC_INVOICE_DATE_FULLPAY_CMB = DTP_BLOCK[1];
		SEARCH_REC_INVOICE_DATE_FULLPAY_FROM_DTP = DTP_BLOCK[2];
		SEARCH_REC_INVOICE_DATE_FULLPAY_TO_DTP = DTP_BLOCK[3];
		
		REC_INVOICE_ACC_ACCOUNT_ID_CMB = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_ACC_ACCOUNT_ID_CMB");
		REC_INVOICE_PAYMENT_STATUS_CMB = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_PAYMENT_STATUS_CMB");
		REC_INVOICE_STATUS_CMB = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_STATUS_CMB");
		REC_INVOICE_ID_FILE_FP = JSCUS_PG._TOOL.APPLY_COMMON_SETUP("REC_INVOICE_ID_FILE_FP");
				
		
		// Initialize: Default Settings
		// ...........................................
		// FORM_PREPARE_DEFAULT_SETTINGS();   	
	};